namespace View_by_Distance.Shared.Models.Stateless;

public interface IDate
{

    (bool?, string[]) TestStatic_IsWrongYear(DirectoryInfo directoryInfo, FilePath filePath, ExifDirectory exifDirectory) =>
        IsWrongYear(directoryInfo, filePath, exifDirectory);
    static (bool?, string[]) IsWrongYear(DirectoryInfo directoryInfo, FilePath filePath, ExifDirectory exifDirectory) =>
        XDate.IsWrongYear(directoryInfo, filePath, exifDirectory);

    (int Season, string seasonName) TestStatic_GetSeason(int dayOfYear) =>
        GetSeason(dayOfYear);
    static (int Season, string seasonName) GetSeason(int dayOfYear) =>
        XDate.GetSeason(dayOfYear);

    DateTime? TestStatic_GetDateTimeOriginal(ExifDirectory exifDirectory) =>
        GetDateTimeOriginal(exifDirectory);
    static DateTime? GetDateTimeOriginal(ExifDirectory exifDirectory) =>
        XDate.GetDateTimeOriginal(exifDirectory);

    DateTime TestStatic_GetMinimum(ExifDirectory exifDirectory) =>
        GetMinimum(exifDirectory);
    static DateTime GetMinimum(ExifDirectory exifDirectory) =>
        XDate.GetMinimum(exifDirectory);

}