
using System.Text.Json;
using System.Text.Json.Serialization;

namespace View_by_Distance.Windows.Models;

public record WindowsSettings(string Company,
                             string? Host,
                             string[] IgnoreExtensions,
                             int MaxDegreeOfParallelism,
                             string? Page,
                             string[] SidecarExtensions,
                             string[] ValidImageFormatExtensions,
                             string[] ValidVideoFormatExtensions,
                             bool VerifyOnly) : Shared.Models.Properties.IWindowsSettings
{

    public override string ToString()
    {
        string result = JsonSerializer.Serialize(this, WindowsSettingsSourceGenerationContext.Default.WindowsSettings);
        return result;
    }

}

[JsonSourceGenerationOptions(WriteIndented = true)]
[JsonSerializable(typeof(WindowsSettings))]
internal partial class WindowsSettingsSourceGenerationContext : JsonSerializerContext
{
}